Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 7309)
@@ -17,8 +17,6 @@
    USE phycst           ! physical constants
    USE dom_oce          ! ocean space and time domain
-   USE sbc_oce          ! Surface boundary condition: ocean fields
    USE sbc_ice          ! Surface boundary condition: ice   fields
    USE ice              ! LIM-3 variables
-   USE dom_ice          ! LIM-3 domain
    USE limrhg           ! LIM-3 rheology
    USE lbclnk           ! lateral boundary conditions - MPP exchanges
@@ -26,8 +24,8 @@
    USE wrk_nemo         ! work arrays
    USE in_out_manager   ! I/O manager
-   USE prtctl           ! Print control
    USE lib_fortran      ! glob_sum
-   USE timing          ! Timing
-   USE limcons        ! conservation tests
+   USE timing           ! Timing
+   USE limcons          ! conservation tests
+   USE limctl           ! control prints
    USE limvar
 
@@ -35,5 +33,6 @@
    PRIVATE
 
-   PUBLIC   lim_dyn   ! routine called by ice_step
+   PUBLIC   lim_dyn        ! routine called by sbcice_lim.F90
+   PUBLIC   lim_dyn_init   ! routine called by sbcice_lim.F90
 
    !! * Substitutions
@@ -50,5 +49,5 @@
       !!               ***  ROUTINE lim_dyn  ***
       !!               
-      !! ** Purpose :   compute ice velocity and ocean-ice stress
+      !! ** Purpose :   compute ice velocity
       !!                
       !! ** Method  : 
@@ -56,16 +55,8 @@
       !! ** Action  : - Initialisation
       !!              - Call of the dynamic routine for each hemisphere
-      !!              - computation of the stress at the ocean surface         
-      !!              - treatment of the case if no ice dynamic
       !!------------------------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt     ! number of iteration
       !!
-      INTEGER  ::   ji, jj, jl, ja    ! dummy loop indices
-      INTEGER  ::   i_j1, i_jpj       ! Starting/ending j-indices for rheology
-      REAL(wp) ::   zcoef             ! local scalar
-      REAL(wp), POINTER, DIMENSION(:)   ::   zswitch        ! i-averaged indicator of sea-ice
-      REAL(wp), POINTER, DIMENSION(:)   ::   zmsk           ! i-averaged of tmask
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zu_io, zv_io   ! ice-ocean velocity
-      !
+      INTEGER  :: jl, jk ! dummy loop indices
       REAL(wp) :: zvi_b, zsmv_b, zei_b, zfs_b, zfw_b, zft_b 
      !!---------------------------------------------------------------------
@@ -73,155 +64,30 @@
       IF( nn_timing == 1 )  CALL timing_start('limdyn')
 
-      CALL wrk_alloc( jpi, jpj, zu_io, zv_io )
-      CALL wrk_alloc( jpj, zswitch, zmsk )
-
-      CALL lim_var_agg(1)             ! aggregate ice categories
-
-      IF( kt == nit000 )   CALL lim_dyn_init   ! Initialization (first time-step only)
-
-      IF( ln_limdyn ) THEN
-         !
-         ! conservation test
-         IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limdyn', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-         u_ice_b(:,:) = u_ice(:,:) * umask(:,:,1)
-         v_ice_b(:,:) = v_ice(:,:) * vmask(:,:,1)
-
-         ! Rheology (ice dynamics)
-         ! ========
-
-         !  Define the j-limits where ice rheology is computed
-         ! ---------------------------------------------------
-
-         IF( lk_mpp .OR. lk_mpp_rep ) THEN                    ! mpp: compute over the whole domain
-            i_j1 = 1
-            i_jpj = jpj
-            IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-            CALL lim_rhg( i_j1, i_jpj )
-         ELSE                                 ! optimization of the computational area
-            !
-            DO jj = 1, jpj
-               zswitch(jj) = SUM( 1.0 - at_i(:,jj) )   ! = REAL(jpj) if ocean everywhere on a j-line
-               zmsk   (jj) = SUM( tmask(:,jj,1)    )   ! = 0         if land  everywhere on a j-line
-            END DO
-
-            IF( l_jeq ) THEN                     ! local domain include both hemisphere
-               !                                 ! Rheology is computed in each hemisphere
-               !                                 ! only over the ice cover latitude strip
-               ! Northern hemisphere
-               i_j1  = njeq
-               i_jpj = jpj
-               DO WHILE ( i_j1 <= jpj .AND. zswitch(i_j1) == FLOAT(jpi) .AND. zmsk(i_j1) /=0 )
-                  i_j1 = i_j1 + 1
-               END DO
-               i_j1 = MAX( 1, i_j1-2 )
-               IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  : NH  i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-               CALL lim_rhg( i_j1, i_jpj )
-               !
-               ! Southern hemisphere
-               i_j1  =  1
-               i_jpj = njeq
-               DO WHILE ( i_jpj >= 1 .AND. zswitch(i_jpj) == FLOAT(jpi) .AND. zmsk(i_jpj) /=0 )
-                  i_jpj = i_jpj - 1
-               END DO
-               i_jpj = MIN( jpj, i_jpj+1 )
-               IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  : SH  i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-               !
-               CALL lim_rhg( i_j1, i_jpj )
-               !
-            ELSE                                 ! local domain extends over one hemisphere only
-               !                                 ! Rheology is computed only over the ice cover
-               !                                 ! latitude strip
-               i_j1  = 1
-               DO WHILE ( i_j1 <= jpj .AND. zswitch(i_j1) == FLOAT(jpi) .AND. zmsk(i_j1) /=0 )
-                  i_j1 = i_j1 + 1
-               END DO
-               i_j1 = MAX( 1, i_j1-2 )
-
-               i_jpj  = jpj
-               DO WHILE ( i_jpj >= 1  .AND. zswitch(i_jpj) == FLOAT(jpi) .AND. zmsk(i_jpj) /=0 )
-                  i_jpj = i_jpj - 1
-               END DO
-               i_jpj = MIN( jpj, i_jpj+1)
-               !
-               IF(ln_ctl) CALL prt_ctl_info( 'lim_dyn  : one hemisphere:  i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-               !
-               CALL lim_rhg( i_j1, i_jpj )
-               !
-            ENDIF
-            !
-         ENDIF
-
-         ! computation of friction velocity
-         ! --------------------------------
-         ! ice-ocean velocity at U & V-points (u_ice v_ice at U- & V-points ; ssu_m, ssv_m at U- & V-points)
-         zu_io(:,:) = u_ice(:,:) - ssu_m(:,:)
-         zv_io(:,:) = v_ice(:,:) - ssv_m(:,:)
-         ! frictional velocity at T-point
-         zcoef = 0.5_wp * rn_cio
-         DO jj = 2, jpjm1 
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ust2s(ji,jj) = zcoef * (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
-                  &                    + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1) ) * tmask(ji,jj,1)
-            END DO
-         END DO
-         !
-         ! conservation test
-         IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limdyn', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-         !
-      ELSE      ! no ice dynamics : transmit directly the atmospheric stress to the ocean
-         !
-         zcoef = SQRT( 0.5_wp ) * r1_rau0
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ust2s(ji,jj) = zcoef * SQRT(  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
-                  &                        + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1) ) * tmask(ji,jj,1)
-            END DO
-         END DO
-         !
-      ENDIF
-      CALL lbc_lnk( ust2s, 'T',  1. )   ! T-point
-
-      IF(ln_ctl) THEN   ! Control print
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=ust2s     , clinfo1=' lim_dyn  : ust2s     :')
-         CALL prt_ctl(tab2d_1=divu_i    , clinfo1=' lim_dyn  : divu_i    :')
-         CALL prt_ctl(tab2d_1=delta_i   , clinfo1=' lim_dyn  : delta_i   :')
-         CALL prt_ctl(tab2d_1=strength  , clinfo1=' lim_dyn  : strength  :')
-         CALL prt_ctl(tab2d_1=e1e2t     , clinfo1=' lim_dyn  : cell area :')
-         CALL prt_ctl(tab2d_1=at_i      , clinfo1=' lim_dyn  : at_i      :')
-         CALL prt_ctl(tab2d_1=vt_i      , clinfo1=' lim_dyn  : vt_i      :')
-         CALL prt_ctl(tab2d_1=vt_s      , clinfo1=' lim_dyn  : vt_s      :')
-         CALL prt_ctl(tab2d_1=stress1_i , clinfo1=' lim_dyn  : stress1_i :')
-         CALL prt_ctl(tab2d_1=stress2_i , clinfo1=' lim_dyn  : stress2_i :')
-         CALL prt_ctl(tab2d_1=stress12_i, clinfo1=' lim_dyn  : stress12_i:')
+      CALL lim_var_agg(1)                      ! aggregate ice categories
+      !
+      ! conservation test
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limdyn', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      
+      ! ice velocities before rheology
+      u_ice_b(:,:) = u_ice(:,:) * umask(:,:,1)
+      v_ice_b(:,:) = v_ice(:,:) * vmask(:,:,1)
+      
+      ! Landfast ice parameterization: define max bottom friction
+      tau_icebfr(:,:) = 0._wp
+      IF( ln_landfast ) THEN
          DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=a_i   (:,:,jl)   , clinfo1= ' lim_dyn  : a_i      : ')
-            CALL prt_ctl(tab2d_1=ht_i  (:,:,jl)   , clinfo1= ' lim_dyn  : ht_i     : ')
-            CALL prt_ctl(tab2d_1=ht_s  (:,:,jl)   , clinfo1= ' lim_dyn  : ht_s     : ')
-            CALL prt_ctl(tab2d_1=v_i   (:,:,jl)   , clinfo1= ' lim_dyn  : v_i      : ')
-            CALL prt_ctl(tab2d_1=v_s   (:,:,jl)   , clinfo1= ' lim_dyn  : v_s      : ')
-            CALL prt_ctl(tab2d_1=e_s   (:,:,1,jl) , clinfo1= ' lim_dyn  : e_s      : ')
-            CALL prt_ctl(tab2d_1=t_su  (:,:,jl)   , clinfo1= ' lim_dyn  : t_su     : ')
-            CALL prt_ctl(tab2d_1=t_s   (:,:,1,jl) , clinfo1= ' lim_dyn  : t_snow   : ')
-            CALL prt_ctl(tab2d_1=sm_i  (:,:,jl)   , clinfo1= ' lim_dyn  : sm_i     : ')
-            CALL prt_ctl(tab2d_1=smv_i (:,:,jl)   , clinfo1= ' lim_dyn  : smv_i    : ')
-            DO ja = 1, nlay_i
-               CALL prt_ctl_info(' ')
-               CALL prt_ctl_info(' - Layer : ', ivar1=ja)
-               CALL prt_ctl_info('   ~~~~~~~')
-               CALL prt_ctl(tab2d_1=t_i(:,:,ja,jl) , clinfo1= ' lim_dyn  : t_i      : ')
-               CALL prt_ctl(tab2d_1=e_i(:,:,ja,jl) , clinfo1= ' lim_dyn  : e_i      : ')
-            END DO
+            WHERE( ht_i(:,:,jl) > ht(:,:) * rn_gamma )  tau_icebfr(:,:) = tau_icebfr(:,:) + a_i(:,:,jl) * rn_icebfr
          END DO
       ENDIF
+      
+      ! Rheology (ice dynamics)
+      ! ========     
+      CALL lim_rhg
       !
-      CALL wrk_dealloc( jpi, jpj, zu_io, zv_io )
-      CALL wrk_dealloc( jpj, zswitch, zmsk )
+      ! conservation test
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limdyn', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+
+      ! Control prints
+      IF( ln_ctl )       CALL lim_prt3D( 'limdyn' )
       !
       IF( nn_timing == 1 )  CALL timing_stop('limdyn')
@@ -243,8 +109,7 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicedyn/ nn_icestr, ln_icestr_bvf, rn_pe_rdg, rn_pstar, rn_crhg, rn_cio,  rn_creepl, rn_ecc, &
-         &                nn_nevp, rn_relast, nn_ahi0, rn_ahi0_ref
-      INTEGER  ::   ji, jj
-      REAL(wp) ::   za00, zd_max
+      NAMELIST/namicedyn/ nn_limadv, nn_limadv_ord,  &
+         &                nn_icestr, ln_icestr_bvf, rn_pe_rdg, rn_pstar, rn_crhg, rn_cio, rn_creepl, rn_ecc, &
+         &                nn_nevp, rn_relast, ln_landfast, rn_gamma, rn_icebfr, rn_lfrelax
       !!-------------------------------------------------------------------
 
@@ -262,64 +127,24 @@
          WRITE(numout,*) 'lim_dyn_init : ice parameters for ice dynamics '
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*)'    ice strength parameterization (0=Hibler 1=Rothrock)  nn_icestr     = ', nn_icestr 
-         WRITE(numout,*)'    Including brine volume in ice strength comp.         ln_icestr_bvf = ', ln_icestr_bvf
-         WRITE(numout,*)'   Ratio of ridging work to PotEner change in ridging    rn_pe_rdg     = ', rn_pe_rdg 
-         WRITE(numout,*) '   drag coefficient for oceanic stress                  rn_cio        = ', rn_cio
-         WRITE(numout,*) '   first bulk-rheology parameter                        rn_pstar      = ', rn_pstar
-         WRITE(numout,*) '   second bulk-rhelogy parameter                        rn_crhg       = ', rn_crhg
-         WRITE(numout,*) '   creep limit                                          rn_creepl     = ', rn_creepl
-         WRITE(numout,*) '   eccentricity of the elliptical yield curve           rn_ecc        = ', rn_ecc
-         WRITE(numout,*) '   number of iterations for subcycling                  nn_nevp       = ', nn_nevp
-         WRITE(numout,*) '   ratio of elastic timescale over ice time step        rn_relast     = ', rn_relast
-         WRITE(numout,*) '   horizontal diffusivity calculation                   nn_ahi0       = ', nn_ahi0
-         WRITE(numout,*) '   horizontal diffusivity coeff. (orca2 grid)           rn_ahi0_ref   = ', rn_ahi0_ref
+         ! limtrp
+         WRITE(numout,*)'    choose the advection scheme (-1=Prather, 0=Ulimate-Macho)   nn_limadv     = ', nn_limadv 
+         WRITE(numout,*)'    choose the order of the scheme (if ultimate)                nn_limadv_ord = ', nn_limadv_ord  
+         ! limrhg
+         WRITE(numout,*)'    ice strength parameterization (0=Hibler 1=Rothrock)         nn_icestr     = ', nn_icestr 
+         WRITE(numout,*)'    Including brine volume in ice strength comp.                ln_icestr_bvf = ', ln_icestr_bvf
+         WRITE(numout,*)'    Ratio of ridging work to PotEner change in ridging          rn_pe_rdg     = ', rn_pe_rdg 
+         WRITE(numout,*) '   drag coefficient for oceanic stress                         rn_cio        = ', rn_cio
+         WRITE(numout,*) '   first bulk-rheology parameter                               rn_pstar      = ', rn_pstar
+         WRITE(numout,*) '   second bulk-rhelogy parameter                               rn_crhg       = ', rn_crhg
+         WRITE(numout,*) '   creep limit                                                 rn_creepl     = ', rn_creepl
+         WRITE(numout,*) '   eccentricity of the elliptical yield curve                  rn_ecc        = ', rn_ecc
+         WRITE(numout,*) '   number of iterations for subcycling                         nn_nevp       = ', nn_nevp
+         WRITE(numout,*) '   ratio of elastic timescale over ice time step               rn_relast     = ', rn_relast
+         WRITE(numout,*) '   Landfast: param (T or F)                                    ln_landfast   = ', ln_landfast
+         WRITE(numout,*) '   Landfast: fraction of ocean depth that ice must reach       rn_gamma      = ', rn_gamma
+         WRITE(numout,*) '   Landfast: maximum bottom stress per unit area of contact    rn_icebfr     = ', rn_icebfr
+         WRITE(numout,*) '   Landfast: relax time scale (s-1) to reach static friction   rn_lfrelax    = ', rn_lfrelax
       ENDIF
       !
-      usecc2 = 1._wp / ( rn_ecc * rn_ecc )
-      rhoco  = rau0  * rn_cio
-      !
-      !  Diffusion coefficients
-      SELECT CASE( nn_ahi0 )
-
-      CASE( 0 )
-         ahiu(:,:) = rn_ahi0_ref
-         ahiv(:,:) = rn_ahi0_ref
-
-         IF(lwp) WRITE(numout,*) ''
-         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim constant = rn_ahi0_ref'
-
-      CASE( 1 ) 
-
-         zd_max = MAX( MAXVAL( e1t(:,:) ), MAXVAL( e2t(:,:) ) )
-         IF( lk_mpp )   CALL mpp_max( zd_max )          ! max over the global domain
-         
-         ahiu(:,:) = rn_ahi0_ref * zd_max * 1.e-05_wp   ! 1.e05 = 100km = max grid space at 60° latitude in orca2
-                                                        !                    (60° = min latitude for ice cover)  
-         ahiv(:,:) = rn_ahi0_ref * zd_max * 1.e-05_wp
-
-         IF(lwp) WRITE(numout,*) ''
-         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim proportional to max of e1 e2 over the domain (', zd_max, ')'
-         IF(lwp) WRITE(numout,*) '   value for ahim = ', rn_ahi0_ref * zd_max * 1.e-05_wp 
-         
-      CASE( 2 ) 
-
-         zd_max = MAX( MAXVAL( e1t(:,:) ), MAXVAL( e2t(:,:) ) )
-         IF( lk_mpp )   CALL mpp_max( zd_max )   ! max over the global domain
-         
-         za00 = rn_ahi0_ref * 1.e-05_wp          ! 1.e05 = 100km = max grid space at 60° latitude in orca2
-                                                 !                    (60° = min latitude for ice cover)  
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               ahiu(ji,jj) = za00 * MAX( e1t(ji,jj), e2t(ji,jj) ) * umask(ji,jj,1)
-               ahiv(ji,jj) = za00 * MAX( e1f(ji,jj), e2f(ji,jj) ) * vmask(ji,jj,1)
-            END DO
-         END DO
-         !
-         IF(lwp) WRITE(numout,*) ''
-         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim proportional to e1'
-         IF(lwp) WRITE(numout,*) '   maximum grid-spacing = ', zd_max, ' maximum value for ahim = ', za00*zd_max
-         
-      END SELECT
-
    END SUBROUTINE lim_dyn_init
 
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limhdf.F90	(revision 7309)
@@ -7,5 +7,5 @@
    !!             -   !  2001-05 (G. Madec, R. Hordoir) opa norm
    !!            1.0  !  2002-08 (C. Ethe)  F90, free form
-   !!            3.0  !  2015-08 (O. Tintó and M. Castrillo)  added lim_hdf (multiple)
+   !!            3.6  !  2015-08 (O. Tintó and M. Castrillo)  added lim_hdf (multiple)
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -28,9 +28,8 @@
    PRIVATE
 
-   PUBLIC   lim_hdf ! called by lim_trp
+   PUBLIC   lim_hdf         ! called by lim_trp
    PUBLIC   lim_hdf_init    ! called by sbc_lim_init
 
    LOGICAL  ::   linit = .TRUE.                             ! initialization flag (set to flase after the 1st call)
-   INTEGER  ::   nn_convfrq                                 !:  convergence check frequency of the Crant-Nicholson scheme
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   efact   ! metric coefficient
 
@@ -44,5 +43,5 @@
 CONTAINS
 
-   SUBROUTINE lim_hdf( ptab , ihdf_vars , jpl , nlay_i )
+   SUBROUTINE lim_hdf( ptab, ihdf_vars )
       !!-------------------------------------------------------------------
       !!                  ***  ROUTINE lim_hdf  ***
@@ -55,41 +54,41 @@
       !! ** Action  :    update ptab with the diffusive contribution
       !!-------------------------------------------------------------------
-      INTEGER                           :: jpl, nlay_i, isize, ihdf_vars
-      REAL(wp),  DIMENSION(:,:,:), INTENT( inout ),TARGET ::   ptab    ! Field on which the diffusion is applied
-      !
-      INTEGER                           ::  ji, jj, jk, jl , jm               ! dummy loop indices
-      INTEGER                           ::  iter, ierr           ! local integers
-      REAL(wp)                          ::  zrlxint     ! local scalars
-      REAL(wp), POINTER , DIMENSION ( : )        :: zconv     ! local scalars
-      REAL(wp), POINTER , DIMENSION(:,:,:) ::  zrlx,zdiv0, ztab0
-      REAL(wp), POINTER , DIMENSION(:,:) ::  zflu, zflv, zdiv
-      CHARACTER(lc)                     ::  charout                   ! local character
-      REAL(wp), PARAMETER               ::  zrelax = 0.5_wp           ! relaxation constant for iterative procedure
-      REAL(wp), PARAMETER               ::  zalfa  = 0.5_wp           ! =1.0/0.5/0.0 = implicit/Cranck-Nicholson/explicit
-      INTEGER , PARAMETER               ::  its    = 100              ! Maximum number of iteration
+      INTEGER,                    INTENT( in )            ::  ihdf_vars ! number of fields to diffuse
+      REAL(wp), DIMENSION(:,:,:), INTENT( inout ), TARGET ::  ptab      ! Field on which the diffusion is applied
+      !
+      INTEGER                             ::  ji, jj, jk, jl, jm        ! dummy loop indices
+      INTEGER                             ::  iter, ierr, isize         ! local integers
+      REAL(wp)                            ::  zrlxint
+      CHARACTER(lc)                       ::  charout                   ! local character
+      REAL(wp), PARAMETER                 ::  zrelax = 0.5_wp           ! relaxation constant for iterative procedure
+      REAL(wp), PARAMETER                 ::  zalfa  = 0.5_wp           ! =1.0/0.5/0.0 = implicit/Cranck-Nicholson/explicit
+      INTEGER , PARAMETER                 ::  num_iter_max = 100        ! Maximum number of iteration
+      INTEGER , PARAMETER                 ::  num_convfrq  = 5          ! convergence check frequency of the Crant-Nicholson scheme (perf. optimization)
+      REAL(wp), POINTER, DIMENSION(:)     ::  zconv
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zrlx, zdiv0, ztab0
+      REAL(wp), POINTER, DIMENSION(:,:)   ::  zflu, zflv, zdiv
       !!-------------------------------------------------------------------
       TYPE(arrayptr)   , ALLOCATABLE, DIMENSION(:) ::   pt2d_array, zrlx_array
-      CHARACTER(len=1) , ALLOCATABLE, DIMENSION(:) ::   type_array ! define the nature of ptab array grid-points
-      !                                                            ! = T , U , V , F , W and I points
-      REAL(wp)        , ALLOCATABLE, DIMENSION(:)  ::   psgn_array    ! =-1 the sign change across the north fold boundary
-
-     !!--------------------------------------------------------------------- 
-
+      CHARACTER(len=1) , ALLOCATABLE, DIMENSION(:) ::   type_array      ! define the nature of ptab array grid-points
+      !                                                                 ! = T , U , V , F , W and I points
+      REAL(wp)         , ALLOCATABLE, DIMENSION(:) ::   psgn_array      ! =-1 the sign change across the north fold boundary
+      !!-------------------------------------------------------------------
+      
       !                       !==  Initialisation  ==!
       ! +1 open water diffusion
-      isize = jpl*(ihdf_vars+nlay_i)+1
+      isize = jpl * ( ihdf_vars + nlay_i ) + 1
       ALLOCATE( zconv (isize) )
       ALLOCATE( pt2d_array(isize) , zrlx_array(isize) )
       ALLOCATE( type_array(isize) )
       ALLOCATE( psgn_array(isize) )
+
+      CALL wrk_alloc( jpi,jpj,       zflu, zflv, zdiv )
+      CALL wrk_alloc( jpi,jpj,isize, zrlx, zdiv0, ztab0 )
       
-      CALL wrk_alloc( jpi, jpj, isize, zrlx, zdiv0, ztab0 )
-      CALL wrk_alloc( jpi, jpj, zflu, zflv, zdiv )
-
-      DO jk= 1 , isize
-         pt2d_array(jk)%pt2d=>ptab(:,:,jk)
-         zrlx_array(jk)%pt2d=>zrlx(:,:,jk)
-         type_array(jk)='T'
-         psgn_array(jk)=1.
+      DO jk= 1, isize
+         pt2d_array(jk)%pt2d => ptab(:,:,jk)
+         zrlx_array(jk)%pt2d => zrlx(:,:,jk)
+         type_array(jk) = 'T'
+         psgn_array(jk) = 1.
       END DO
 
@@ -99,5 +98,5 @@
          IF( lk_mpp    )   CALL mpp_sum( ierr )
          IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'lim_hdf : unable to allocate arrays' )
-         DO jj = 2, jpjm1
+         DO jj = 2, jpjm1  
             DO ji = fs_2 , fs_jpim1   ! vector opt.
                efact(ji,jj) = ( e2u(ji,jj) + e2u(ji-1,jj) + e1v(ji,jj) + e1v(ji,jj-1) ) * r1_e1e2t(ji,jj)
@@ -106,11 +105,10 @@
          linit = .FALSE.
       ENDIF
-      !                             ! Time integration parameters
-      !
-      zflu (jpi,: ) = 0._wp
-      zflv (jpi,: ) = 0._wp
-
+      !
+      ! Arrays initialization
+      zflu(jpi,:) = 0._wp   
+      zflv(jpi,:) = 0._wp
       DO jk=1 , isize
-         ztab0(:, : , jk ) = ptab(:,:,jk)      ! Arrays initialization
+         ztab0(:, : , jk ) = ptab(:,:,jk)
          zdiv0(:, 1 , jk ) = 0._wp
          zdiv0(:,jpj, jk ) = 0._wp
@@ -119,14 +117,15 @@
       END DO
 
-      zconv = 1._wp           !==  horizontal diffusion using a Crant-Nicholson scheme  ==!
-      iter  = 0
-      !
-      DO WHILE( MAXVAL(zconv(:)) > ( 2._wp * 1.e-04 ) .AND. iter <= its )   ! Sub-time step loop
+      !                !==  horizontal diffusion using a Crant-Nicholson scheme  ==!
+      zconv(:) = 1._wp
+      iter     = 0
+      !
+      DO WHILE( MAXVAL( zconv(:) ) > ( 2._wp * 1.e-04 ) .AND. iter <= num_iter_max )   ! Sub-time step loop
          !
          iter = iter + 1                                 ! incrementation of the sub-time step number
          !
          DO jk = 1 , isize
-            jl = (jk-1) /( ihdf_vars+nlay_i)+1
-            IF (zconv(jk) > ( 2._wp * 1.e-04 )) THEN
+            jl = ( jk - 1 ) / ( ihdf_vars + nlay_i ) + 1
+            IF ( zconv(jk) > ( 2._wp * 1.e-04 ) ) THEN
                DO jj = 1, jpjm1                                ! diffusive fluxes in U- and V- direction
                   DO ji = 1 , fs_jpim1   ! vector opt.
@@ -159,6 +158,7 @@
          CALL lbc_lnk_multi( zrlx_array, type_array , psgn_array , isize ) ! Multiple interchange of all the variables
          !
-         IF ( MOD( iter-1 , nn_convfrq ) == 0 )  THEN   !Convergence test every nn_convfrq iterations (perf. optimization ) 
-            DO jk=1,isize
+
+         IF ( MOD( iter-1 , num_convfrq ) == 0 )  THEN   ! Convergence test every num_convfrq iterations (perf. optimization ) 
+            DO jk = 1, isize
                zconv(jk) = 0._wp                                   ! convergence test
                DO jj = 2, jpjm1
@@ -175,10 +175,9 @@
          END DO
          !
-      END DO                                       ! end of sub-time step loop
-
-     ! -----------------------
-      !!! final step (clem) !!!
+      END DO  ! end of sub-time step loop
+
+     ! --- final step --- !
       DO jk = 1, isize
-         jl = (jk-1) /( ihdf_vars+nlay_i)+1
+         jl = ( jk - 1 ) / ( ihdf_vars + nlay_i ) + 1
          DO jj = 1, jpjm1                                ! diffusive fluxes in U- and V- direction
             DO ji = 1 , fs_jpim1   ! vector opt.
@@ -198,7 +197,5 @@
       CALL lbc_lnk_multi( pt2d_array, type_array , psgn_array , isize ) ! Multiple interchange of all the variables
 
-      !!! final step (clem) !!!
-      ! -----------------------
-
+      !
       IF(ln_ctl)   THEN
          DO jk = 1 , isize
@@ -209,7 +206,7 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, isize, zrlx, zdiv0, ztab0 )
-      CALL wrk_dealloc( jpi, jpj, zflu, zflv, zdiv )
-
+      CALL wrk_dealloc( jpi,jpj,       zflu, zflv, zdiv )
+      CALL wrk_dealloc( jpi,jpj,isize, zrlx, zdiv0, ztab0 )
+      !
       DEALLOCATE( zconv )
       DEALLOCATE( pt2d_array , zrlx_array )
@@ -219,5 +216,4 @@
    END SUBROUTINE lim_hdf
 
-
    
    SUBROUTINE lim_hdf_init
@@ -232,12 +228,8 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicehdf/ nn_convfrq 
-      !!-------------------------------------------------------------------
-      !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_hdf : Ice horizontal diffusion'
-         WRITE(numout,*) '~~~~~~~'
-      ENDIF
+      NAMELIST/namicehdf/ nn_ahi0, rn_ahi0_ref
+      INTEGER  ::   ji, jj
+      REAL(wp) ::   za00, zd_max
+      !!-------------------------------------------------------------------
       !
       REWIND( numnam_ice_ref )              ! Namelist namicehdf in reference namelist : Ice horizontal diffusion
@@ -252,7 +244,52 @@
       IF(lwp) THEN                          ! control print
          WRITE(numout,*)
-         WRITE(numout,*)'   Namelist of ice parameters for ice horizontal diffusion computation '
-         WRITE(numout,*)'      convergence check frequency of the Crant-Nicholson scheme   nn_convfrq   = ', nn_convfrq
+         WRITE(numout,*) 'lim_hdf_init : Ice horizontal diffusion'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         WRITE(numout,*) '   horizontal diffusivity calculation                          nn_ahi0      = ', nn_ahi0
+         WRITE(numout,*) '   horizontal diffusivity coeff. (orca2 grid)                  rn_ahi0_ref  = ', rn_ahi0_ref
       ENDIF
+      !
+      !  Diffusion coefficients
+      SELECT CASE( nn_ahi0 )
+
+      CASE( 0 )
+         ahiu(:,:) = rn_ahi0_ref
+         ahiv(:,:) = rn_ahi0_ref
+
+         IF(lwp) WRITE(numout,*) ''
+         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim constant = rn_ahi0_ref'
+
+      CASE( 1 ) 
+
+         zd_max = MAX( MAXVAL( e1t(:,:) ), MAXVAL( e2t(:,:) ) )
+         IF( lk_mpp )   CALL mpp_max( zd_max )          ! max over the global domain
+         
+         ahiu(:,:) = rn_ahi0_ref * zd_max * 1.e-05_wp   ! 1.e05 = 100km = max grid space at 60deg latitude in orca2
+                                                        !                    (60deg = min latitude for ice cover)  
+         ahiv(:,:) = rn_ahi0_ref * zd_max * 1.e-05_wp
+
+         IF(lwp) WRITE(numout,*) ''
+         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim proportional to max of e1 e2 over the domain (', zd_max, ')'
+         IF(lwp) WRITE(numout,*) '   value for ahim = ', rn_ahi0_ref * zd_max * 1.e-05_wp 
+         
+      CASE( 2 ) 
+
+         zd_max = MAX( MAXVAL( e1t(:,:) ), MAXVAL( e2t(:,:) ) )
+         IF( lk_mpp )   CALL mpp_max( zd_max )   ! max over the global domain
+         
+         za00 = rn_ahi0_ref * 1.e-05_wp          ! 1.e05 = 100km = max grid space at 60deg latitude in orca2
+                                                 !                    (60deg = min latitude for ice cover)  
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ahiu(ji,jj) = za00 * MAX( e1t(ji,jj), e2t(ji,jj) ) * umask(ji,jj,1)
+               ahiv(ji,jj) = za00 * MAX( e1f(ji,jj), e2f(ji,jj) ) * vmask(ji,jj,1)
+            END DO
+         END DO
+         !
+         IF(lwp) WRITE(numout,*) ''
+         IF(lwp) WRITE(numout,*) '   laplacian operator: ahim proportional to e1'
+         IF(lwp) WRITE(numout,*) '   maximum grid-spacing = ', zd_max, ' maximum value for ahim = ', za00*zd_max
+         
+      END SELECT
       !
    END SUBROUTINE lim_hdf_init
@@ -265,3 +302,2 @@
    !!======================================================================
 END MODULE limhdf
-
